/*
    Trabalho Prtico I - IPDI
    -------------------------
    Anderson de Rezende Rocha <anderson.rocha@ic.unicamp.br>
    Leyza E. Baldo Dorini <leyzad@yahoo.com.br>

    Implementacao do desvio padro em uma rea pr-determinada

    OBSERVAO
    ----------
    Imagem[i,j] = *(Imagem + i * nc + j)
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "imagem.h"
#include "morfo.h"
#include "utils.h"
#include "tratadorErros.h"

// Referncia ao ponteiro /dev/null
#define null 0
// Tamanho da janela
#define TAMJANELA 32

void desvioPadrao(int *imagem, int nl, int nc);

int main (int argc, char *argv[])
{
    int OK, nc, nl, mn, x, y, l, c, i, j;
    int *imagemEntrada;
    int janela[TAMJANELA][TAMJANELA]; 
    int soma, nroElementos, media, desviop;

    y = 0;
    x = 0;
    nroElementos = 1024;    
    desviop = 0;
    soma = 0;
    media = 0;
    l = 0;
    c=0;   

    printf("\nDesvio Padrao by <Anderson Rocha, Leyza Dorini>\n");

    if (argc == 2)
    {
        OK = le_imagem_pgm (argv[1], &imagemEntrada, &nl, &nc, &mn);

        info_imagem (argv[1], nl, nc, mn);
    
        
        //Como no trabalho o desvio padro deveria ser calculado em uma rea especfica (longe
        //da presena de bordas, optou-se por calcular o desvio padro de uma rea de dimenso
        //32x32 com incio nas coordenadas (50,50).        
        for(x = 50; x < 82; x++)
        {
            c = 0;                
            for(y = 50; y < 82; y++)
            {                              
                janela[l][c] = *(imagemEntrada + x * nc + y);                
                c++;                   
            }
            l++;
        }
        
        for(i = 0; i <= 31; i++)
        {
            for(j = 0; j <= 31; j++){            
                soma = soma + janela[i][j];
            }
        }    

        //clculo do desvio padro atravs da frmula especfica para tal.        
        media = (soma / nroElementos);
        for(i = 0; i <= 31; i++)
            for(j = 0; j <= 31; j++)
                desviop += pow((janela[i][j] - media), 2);        
    
        desviop = desviop / (nroElementos-1);                        
        desviop = sqrt(desviop);
    
        printf("O desvio padrao eh: %d\n", desviop);
    

        if(imagemEntrada == null)        
        {
            tratarErro(3);
        }
    }
    else
    {
        tratarSintaxe(1);
    }     
    return(0);
}