/*
    Trabalho Prtico I - IPDI
    -------------------------
    Anderson de Rezende Rocha <anderson.rocha@ic.unicamp.br>
    Leyza E. Baldo Dorini <leyzad@yahoo.com.br>

    Implementacao do filtro do calculo do erro mdio quadrtico

    OBSERVAO
    ----------
    Imagem[i,j] = *(Imagem + i * nc + j)
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "imagem.h"
#include "morfo.h"
#include "utils.h"
#include "tratadorErros.h"

int calculaErro(int *imagemOriginal, int *imagemProcessada, int nl, int nc, int tamanhoJanela);

static int TAMJANELA;

int main (int argc, char *argv[])
{
    int OK, nc, nl, mn;
    int *imagemEntrada;
    int *imagemSaida;
    int l,  m;

    printf("\nClculo do RMS (Rate Mean Square) by <Anderson Rocha, Leyza Dorini>\n");
    if (argc == 4)
    {
        OK = le_imagem_pgm (argv[1], &imagemEntrada, &nl, &nc, &mn);
        OK = le_imagem_pgm (argv[2], &imagemSaida, &nl, &nc, &mn);
        TAMJANELA = atoi(argv[3]);

        info_imagem (argv[1], nl, nc, mn);
        info_imagem (argv[2], nl, nc, mn);       

        printf("RMS de \"%s\" em relacao \"%s\" = %d\n", argv[1], argv[2],
               calculaErro(imagemEntrada, imagemSaida, nl, nc, TAMJANELA));

        desaloca_memo(&imagemSaida);
    }
    else
    {
        tratarSintaxe(5);
    }

    printf("\n");
    return(0);
}

int calculaErro(int *imagemOriginal, int *imagemProcessada, int nl, int nc, int tamanhoJanela)
{
    int i,  j;
    int soma, aux, aux2, erro, erroFinal;
    // Linha inicial e coluna inicial
    // Linha final e coluna final
    int li, ci, lf, cf;

    li = tamanhoJanela/2;
    ci = tamanhoJanela/2;
    lf = nl - li;
    cf = nc - ci;

    soma = 0;
    erro = 0;
    erroFinal = 0;
    aux  = 0;
    aux2  = 0;   

    for(i = li; i < lf; i++)
    {
        for(j = ci; j < cf; j++)
        {
            aux = *(imagemProcessada + i * nc + j) - *(imagemOriginal + i * nc + j);
            aux2 = pow(aux, 2);
            soma = soma + aux2;
        }
    }

    erro = soma / (nl*nc);
    erroFinal = sqrt(erro);

    return erroFinal;
}